restart
loadPackage "StronglyStableIdeals";
loadPackage "MarkedFamiliesWarsaw";

n = 2
KK = ZZ/10007;
R = KK[x_0..x_n];

d1 = 3, d2 = 10
SSI1 = stronglyStableIdeals(d1,R);
SSI2 = stronglyStableIdeals(d2,R);

-- select a suitable pair of strongly stable ideals
J1 = SSI1#-1
J1 = SSI1#(random(#SSI1))
SSI2' = select(SSI2, I -> isSubset(I,J1))
J2 = SSI2'#(random(#SSI2'))
J2 = SSI2'#-1
H1 = time openSubsetHilbertScheme(J1,Minimize=>true);
H2 = time openSubsetHilbertScheme(J2,Minimize=>true,VariableBaseName=>"B");

P1 = ring H1#1;
P2 = ring H2#1;
P = P1**P2;
PR = P[gens R];

MB1 = sub(ideal H1#0#1,PR)
MB2 = sub(ideal H2#0#1,PR)

equations = flatten for g in MB2_* list for t in terms(g%MB1) list leadCoefficient t;
equations = equations | (for e in H1#1_* list sub(e,P)) |  (for e in H2#1_* list sub(e,P))

I = trim ideal equations
trim ((ideal jacobian I) + I)
