restart
loadPackage "StronglyStableIdeals";
loadPackage "MarkedFamiliesWarsaw";

r = 2; g = 4;
d = ceiling((2*g+6)/3)
rho = g-(r+1)*(g+r-d)
expectedDimension = 3*g-3 + rho + (r+1)^2-1
delta = binomial(d-1,2) - g


KK = ZZ/10007;  R = KK[x,y,z];
-- Schreyer: produce a random plane curve of degree d with delta double points
P = intersect(for i from 1 to delta list ideal(random(1,R),random(1,R)))
hilbertPolynomial(P, Projective=>false)
saturate (ideal jacobian P + P)

Psquare = trim P^2;
basisLinearSystem = super basis(d,Psquare);
C = ideal (basisLinearSystem*random(R^{numColumns basisLinearSystem:0},R^{0})) 
saturate (ideal jacobian C + C) == P

totalFreeChoices = 2*delta + (numColumns basisLinearSystem - 1)
totalFreeChoices == expectedDimension

-- parametric plane curve of degree d with delta double points
SSI = stronglyStableIdeals(delta,R);
J = SSI#-1 -- unique strongly stable ideal with the Hilbert function of delta general points
dimTangentSpaceHilbertScheme J == 2*delta
H = openSubsetHilbertScheme(J, Minimize=>true);
H#0
H#1

familyP = ideal H#0#1;
familyPsquare = familyP^2;
basisLinearSystem = rsort flatten entries gens gb super basis(d,familyPsquare);
#basisLinearSystem

S = ring familyP;
pointsParam = coefficientRing S;
linearSystemParam = KK[Variables=>#basisLinearSystem -1,VariableBaseName=>"L"];

dominantSpace = linearSystemParam[gens pointsParam];
SS = dominantSpace[gens S];
generalCurve = ideal ( sub(basisLinearSystem#0,SS) + 
               sum(for i from 1 to #basisLinearSystem - 1 list linearSystemParam_(i-1)*sub(basisLinearSystem#i,SS)))

randomPointsParams = for i from 1 to numgens pointsParam list random (KK);
randomLinearSystemParams = for i from 1 to numgens linearSystemParam list random (KK);

randomPointsMap = map(R,S,gens R | randomPointsParams );
randomCurveMap = map(R,SS,gens R | randomPointsParams | randomLinearSystemParams);

randomPoints = randomPointsMap familyP
randomCurve = randomCurveMap generalCurve

saturate (ideal jacobian randomCurve + randomCurve) == randomPoints
