restart
printWidth=122
loadPackage "gfanInterface";
loadPackage "MarkedFamiliesWarsaw";
KK = QQ; R = KK[x_1..x_5];
F = x_1^2*x_2 + x_1*x_3^2 + x_4^2*x_2 + x_5^2*x_3
apolarF = inverseSystem F
for i from 0 to 4 list hilbertFunction(i,apolarF)

S = KK[gens R | {x_0}];
apolarF' = sub(apolarF,S);

-- check tangent space dimension 
time dimTangentSpaceHilbertScheme apolarF'

-- looking for a smoothable deformation
tangentSpace = time tangentSpaceHilbertScheme (apolarF', Minimize=>true);
PeeS = ring tangentSpace#0#0; Pee = coefficientRing PeeS; P = coefficientRing Pee;
numgens P
tangentSpace#1#0

basisFirstOrderDeformations = {};
for i from 0 to numgens P-1 do (
    singlePar = for j from 0 to numgens P-1 list if j==i then P_j => 1 else P_j=> 0;
    basisFirstOrderDeformations = append(basisFirstOrderDeformations,for p in tangentSpace#1 list sub(p,singlePar));
);

Q = KK[t]; QS = Q[gens S];
possibleDeformations = {};
for def in basisFirstOrderDeformations do (
    ithBasisVectorMap = map(QS,PeeS, (gens QS) | {t});
    possibleDeformations = append(possibleDeformations, for p in def list ithBasisVectorMap p);
);

first basisFirstOrderDeformations
first possibleDeformations

headTerms = for ht in tangentSpace#0 list sub(ht,QS);
unobstructed = {};
for def in possibleDeformations do (
    markedSet = markedPolynomialList {headTerms,def};
    if numgens (markedBasisStarReduction(markedSet))#1 == 0 then
    	unobstructed = append(unobstructed, def);
);
#unobstructed

genericFibers = for def in unobstructed list sub(sub(ideal def,t=>1),S); 
smoothingDeformations = select(genericFibers, J -> #(decompose J) > 1);
#smoothingDeformations
smoothable = primaryDecomposition topComponents smoothingDeformations#0 
for I in smoothable list hilbertPolynomial (I,Projective=>false)


-- randomForm
KK = ZZ/10007; R = KK[x_1..x_5];
F = random(3,R);
apolarF = inverseSystem F
for i from 0 to 4 list hilbertFunction(i,apolarF)

S = KK[gens R | {x_0}];
apolarF' = sub(apolarF,S);
hilbertPolynomial (apolarF', Projective=>false)

time dimTangentSpaceHilbertScheme apolarF'

tangentSpace = time tangentSpaceHilbertScheme (apolarF', Minimize=>true);
PeeR = ring tangentSpace#0#0; Pee = coefficientRing PeeR; P = coefficientRing Pee;
numgens P
tangentSpace#0
tangentSpace#1#0


basisFirstOrderDeformations = {};
for i from 0 to numgens P-1 do (
    singlePar = for j from 0 to numgens P-1 list if j!=i then P_j => 0_P else P_j=>P_j;
    basisFirstOrderDeformations = append(basisFirstOrderDeformations,for p in tangentSpace#1 list sub(p,singlePar));
);
basisFirstOrderDeformations#0

Q = KK[t];
QR = Q[gens PeeR];
possibleDeformations = {};
for i from 0 to numgens P-1 do (
    images = (gens QR) | {Q_0} | for j from 0 to numgens P-1 list if j!=i then 0 else 1;
    specMap = map(QR,PeeR,images);
    possibleDeformations = append(possibleDeformations, for p in basisFirstOrderDeformations#i list specMap p);
);
possibleDeformations#0
headTerms = for ht in tangentSpace#0 list sub(ht,QR);
unobstructed = {};
for def in possibleDeformations do (
    markedSet = markedPolynomialList {headTerms,def};
    if numgens (markedBasisStarReduction(markedSet))#1 == 0 then
    	unobstructed = append(unobstructed, def);
)
#unobstructed

genericFibers = for def in unobstructed list sub(sub(ideal def,t=>1),S); 
smoothingDeformations = select(genericFibers, J -> #(decompose J) > 1);
#smoothingDeformations
smoothing = primaryDecomposition topComponents smoothingDeformations#0 
for I in smoothing list hilbertPolynomial (I,Projective=>false)
